unit DunesAudioMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, OleCtrls, mmsystem, ComCtrls,
  DunesAudio,DunesAudioWAV, DunesAudioWMA, DunesAudioConversion,DunesAudioPlayer,

  {$IFDEF WIN32}
  DunesAudioMP3, DunesAudioOGG, DunesAudioACM, DunesAudioFFMPEG, DunesAudioCDRip,
  {$ENDIF}

  CheckLst, JPEG, ExtCtrls;

type                                   
  TDunesAudioDemoForm = class(TForm)
    Label2: TLabel;
    DestinationTypeComboBox: TComboBox;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SourceFileLabel: TLabel;
    DestinationFileLabel: TLabel;
    SpeedButton2: TSpeedButton;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    FormatComboBox: TComboBox;
    SampleRateCombobox: TComboBox;
    Normalize: TCheckBox;
    Button1: TButton;     
    Button2: TButton;
    Button4: TButton;
    QualityCombobox: TComboBox;
    Label4: TLabel;
    StaticText1: TStaticText;
    InfoMemo: TMemo;
    StaticText2: TStaticText;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EncodeButton: TSpeedButton;
    ProgressBar2: TProgressBar;
    SpeedButton4: TSpeedButton;
    cbCDDrives: TComboBox;
    clTracks: TCheckListBox;
    StaticText3: TStaticText;
    edRipFolder: TEdit;
    Label7: TLabel;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    Label8: TLabel;
    cbSubFormat: TComboBox;
    Label9: TLabel;
    BitRateComboBox: TComboBox;
    VBRCheckBox: TCheckBox;
    MaxBitRateComboBox: TComboBox;
    Label10: TLabel;
    Image1: TImage;
    PaintBox2: TPaintBox;

    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure EncodeButtonClick(Sender: TObject);
    procedure AudioConversionProgress(Sender:TObject; Pass:TAudioConversionPass; Progress:Double);
    procedure Button1Click(Sender: TObject);
    procedure NotifyPosChangeEvent(Sender: TObject; NewPos : DWORD);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ProgressBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure cbCDDrivesChange(Sender: TObject);
    procedure DestinationTypeComboBoxChange(Sender: TObject);
    procedure QualityComboboxChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);

  private
    procedure Encode(SourceAudio, DestinationAudio: TAudio);
    procedure EncodeFile(SourceAudio: TAudio;Destination: string);
    { Private declarations }
  public
    { Public declarations }
    SourceAudio:TAudio;
    DestinationAudioClass:TAudioClass;
    AudioPlayer:TAudioPlayer;
    UpdateTime:TDateTime;
    {$IFDEF WIN32}
    AudioCDRip:TAudioCDRip;
    {$ENDIF}
  end;

var
  DunesAudioDemoForm: TDunesAudioDemoForm;

implementation

uses WaveIO, msacm;

{$R *.dfm}

procedure TDunesAudioDemoForm.SpeedButton1Click(Sender: TObject);
var
  HasFileInfo:Boolean;
begin
  if OpenDialog1.Execute then
  begin
    AudioPlayer.Stop;
    if assigned(AudioPlayer.InputAudio) then
    begin
      AudioPlayer.InputAudio.Free;
      AudioPlayer.InputAudio := nil;
    end;

    SourceFileLabel.Caption:=Extractfilename(OpenDialog1.FileName);
    AudioPlayer.InputAudio := Audio.CreateAudio(OpenDialog1.FileName,acDecode);
    if Assigned(AudioPlayer.InputAudio) then
    begin
      HasFileInfo := AudioPlayer.InputAudio.ReadFileInfo;
      if not AudioPlayer.InputAudio.OpenReadStream then
      begin
        ShowMessage('Cannot open input file');
        exit;
      end;
      InfoMemo.Lines.Add('Player audio class: '+AudioPlayer.InputAudio.ClassName);
      InfoMemo.Lines.Add('Format: '+AudioPlayer.InputAudio.AudioFormat.AsString);
      InfoMemo.Lines.Add('Duration: '#9+FormatDateTime('hh:nn:ss:zzz',AudioPlayer.InputAudio.Duration/(1000*SecsPerDay)));

      if HasFileInfo then
      begin
        InfoMemo.Lines.Add('Tag: ');
        InfoMemo.Lines.Add(' - Title: '#9+AudioPlayer.InputAudio.AudioTag.Title);
        InfoMemo.Lines.Add(' - Artist: '#9+AudioPlayer.InputAudio.AudioTag.Artist);
        InfoMemo.Lines.Add(' - Album: '#9+AudioPlayer.InputAudio.AudioTag.Album);
        InfoMemo.Lines.Add(' - Genre: '#9+AudioPlayer.InputAudio.AudioTag.Genre);
        InfoMemo.Lines.Add(' - Comment: '#9+AudioPlayer.InputAudio.AudioTag.Comment);
        InfoMemo.Lines.Add(' - Track: '#9+AudioPlayer.InputAudio.AudioTag.Track);
      end else
        InfoMemo.Lines.Add('No Fileinfo... ');
    end;
  end;
end;

procedure TDunesAudioDemoForm.SpeedButton2Click(Sender: TObject);
begin
  SaveDialog1.Filter:='Audio File|*'+ DestinationTypeComboBox.Text;

  if DestinationTypeComboBox.ItemIndex = 4 then
    SaveDialog1.Filter:='Audio File|*.wav';

  if SaveDialog1.Execute then
  begin
    EncodeButton.Enabled := Assigned(SourceAudio);
  end;
end;

procedure TDunesAudioDemoForm.SpeedButton3Click(Sender: TObject);
begin
  SpeedButton2.Enabled := False;
  if assigned(SourceAudio) then
    FreeAndNil(SourceAudio);
  if OpenDialog1.Execute then
  begin
    SourceAudio := Audio.CreateAudio(OpenDialog1.FileName,acDecode);
    SpeedButton2.Enabled := assigned(SourceAudio);
  end;
end;

procedure TDunesAudioDemoForm.SpeedButton4Click(Sender: TObject);
begin
  {$IFDEF WIN32}
  AudioCDRip:=TAudioCDRip.Create(self);
  AudioCDRip.Debug := InfoMemo.Lines;
  AudioCDRip.Initialize;
  cbCDDrives.Items.Assign(AudioCDRip.Drives);
  if cbCDDrives.Items.Count > 0 then
  begin
    cbCDDrives.Enabled := true;
    cbCDDrives.ItemIndex := 0;
    cbCDDrives.OnChange(self);
  end;
  SpeedButton4.Enabled := False;
  Button4.Enabled := True;
  {$ELSE}
  ShowMessage('CD Rip is not supported in 64 bit');
  {$ENDIF}
end;

procedure TDunesAudioDemoForm.EncodeButtonClick(Sender: TObject);
const
  MaxBufferSize = 4*44100;
begin
  DestinationFileLabel.Caption:=Extractfilename(SaveDialog1.FileName);
  EncodeFile(SourceAudio,SaveDialog1.FileName);
end;

procedure TDunesAudioDemoForm.EncodeFile(SourceAudio: TAudio; Destination: string);
var
  DestinationAudio:TAudio;
begin
  DestinationAudio := Audio.CreateAudioByDescription(DestinationTypeComboBox.Text);
  if DestinationAudio = nil then
  begin
    Label3.Caption:='Status: Destination audio cannot be identified';
    exit;
  end;

  DestinationAudio.AudioFormat.Quality := TAudioQuality(QualityCombobox.ItemIndex);
  if TAudioQuality(QualityCombobox.ItemIndex)=aqCustom then
  begin

    case FormatComboBox.ItemIndex of
      0,2: DestinationAudio.AudioFormat.Channels := 2;
      1,3: DestinationAudio.AudioFormat.Channels := 1;
    end;
    case FormatComboBox.ItemIndex of
      0,1: DestinationAudio.AudioFormat.BitsPerSample := 16;
      2,3: DestinationAudio.AudioFormat.BitsPerSample := 8;
    end;

    case SampleRateCombobox.ItemIndex of
      0: DestinationAudio.AudioFormat.SampleRate := 44100;
      1: DestinationAudio.AudioFormat.SampleRate := 22050;
      2: DestinationAudio.AudioFormat.SampleRate := 11025;
    end;

    if foBitrate in DestinationAudio.AudioFormat.AvailableOptions then
      DestinationAudio.AudioFormat.BitRate := StrToInt(BitRateComboBox.Text);

    if foVBR in DestinationAudio.AudioFormat.AvailableOptions then
      DestinationAudio.AudioFormat.VBR := VBRCheckBox.Checked;

    if foMaxBitRate in DestinationAudio.AudioFormat.AvailableOptions then
      DestinationAudio.AudioFormat.MaxBitRate := StrToInt(MaxBitRateComboBox.Text);

  end;
  DestinationAudio.AudioTag.Assign(SourceAudio.AudioTag);
  DestinationAudio.StreamName := Destination;
  Encode(SourceAudio,DestinationAudio);
  DestinationAudio.Free;
end;

procedure TDunesAudioDemoForm.AudioConversionProgress(Sender:TObject; Pass:TAudioConversionPass; Progress:Double);
begin
  if (Now - UpdateTime) > 0.1/(3600*24) then
  begin
    UpdateTime := Now;
    Case Pass of
      acDecoding:   Label3.Caption :='Status: Decoding';
      acResampling: Label3.Caption :='Status: Resampling';
      acNormalizing:Label3.Caption :='Status: Normalizing';
      acEncoding   :Label3.Caption :='Status: Encoding';
    end;
    ProgressBar2.Position := round(Progress*10);
    Application.ProcessMessages;
  end;
end;

procedure TDunesAudioDemoForm.Button1Click(Sender: TObject);
begin
  AudioPlayer.Play;
end;

procedure TDunesAudioDemoForm.NotifyPosChangeEvent(Sender: TObject; NewPos: DWORD);
begin
  ProgressBar1.Position := round(AudioPlayer.PositionFraction*1000);
end;

procedure TDunesAudioDemoForm.ProgressBar1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  AudioPlayer.PositionFraction := X/ProgressBar1.Width;
end;

procedure TDunesAudioDemoForm.QualityComboboxChange(Sender: TObject);
var
  AudioClass:TAudioClass;
  e:Boolean;
begin
  e := QualityCombobox.ItemIndex = 0;
  FormatComboBox.Enabled := e;
  Label5.Enabled := e;
  Label6.Enabled := e;
  SampleRateCombobox.Enabled := e;

  AudioClass := Audio.GetAudioByDescription(DestinationTypeComboBox.Text);

  Label9.Enabled := e and (foBitrate in AudioClass.AvailableFormatOptions);
  BitRateComboBox.Enabled := e and (foBitrate in AudioClass.AvailableFormatOptions);

  VBRCheckBox.Enabled := e and (foVBR in AudioClass.AvailableFormatOptions);

  Label10.Enabled := e and (foMaxBitRate in AudioClass.AvailableFormatOptions);
  MaxBitRateComboBox.Enabled := e and (foMaxBitRate in AudioClass.AvailableFormatOptions);
end;

procedure TDunesAudioDemoForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if assigned(AudioPlayer) then
  begin
    AudioPlayer.Stop;
    AudioPlayer.Free;
  end;
end;

procedure TDunesAudioDemoForm.FormCreate(Sender: TObject);
var
  i:integer;
begin
  { Fix bug delphi, the content of the comboboxes get lost after a restart of
    delphi }
  FormatComboBox.Items.Text := '16 bit stereo'#13'16 bit mono'#13'8 bit stereo'
    +#13'8 bit mono';
  FormatComboBox.ItemIndex := 0;

  QualityCombobox.Items.Text :='Custom'#13'Phone'#13'Voice'#13'AMRadio'
    +#13'FMRadio'#13'Tape'#13'Hifi'#13'CD'#13'Studio';
  QualityCombobox.ItemIndex := 7;

  BitRateComboBox.Items.Text :='256'#13'192'#13'160'#13'128'#13'96'#13'64'#13'32'#13'16';
  BitRateComboBox.ItemIndex := 2;

  MaxBitRateComboBox.Items.Text :='320'#13'256'#13'192'#13'160'#13'128'#13'96';
  MaxBitRateComboBox.ItemIndex := 1;

  SampleRateCombobox.Items.Text := '44100'#13'22050'#13'11025';
  SampleRateCombobox.ItemIndex := 0;

  AudioPlayer := TAudioPlayer.Create(Self);
  AudioPlayer.OnPosChange := NotifyPosChangeEvent;
  DestinationTypeComboBox.Clear;
  for i:=0 to Audio.Count-1 do
    if acEncode in Audio[i].Capabilities then
      DestinationTypeComboBox.Items.Add(Audio[i].ClassDescription);

  DestinationTypeComboBox.ItemIndex := 0;
  DestinationTypeComboBox.OnChange(self);
  QualityCombobox.OnChange(self);
end;

procedure TDunesAudioDemoForm.Button2Click(Sender: TObject);
begin
  AudioPlayer.Stop;
end;

procedure TDunesAudioDemoForm.Button3Click(Sender: TObject);
begin
  Audio.About;
end;

procedure TDunesAudioDemoForm.Button4Click(Sender: TObject);
var
  i:integer;
  SourceAudio: TAudio;
  FileName:String;
begin
  {$IFDEF WIN32}
  Button4.Enabled := False;
  clTracks.Enabled := False;
  for i:=0 to AudioCDRip.TrackCount-1 do
  begin
    if clTracks.Checked[i] then
    begin
      SourceAudio := AudioCDRip.Tracks[i];
      FileName := Format(IncludeTrailingPathDelimiter(edRipFolder.Text)
        +'%2d - %s.%s',[i+1,AudioCDRip.Tracks[i].AudioTag.Title,cbSubFormat.Text]);
      clTracks.Checked[i] := False;
      clTracks.Header[i] := True;
      EncodeFile(SourceAudio,FileName);
      clTracks.Header[i] := False;
    end;
 end;
  clTracks.Enabled := True;
  Button4.Enabled := True;
  {$ELSE}
  ShowMessage('CD Rip is not supported in 64 bit');
  {$ENDIF}
end;

procedure TDunesAudioDemoForm.Encode(SourceAudio,DestinationAudio:TAudio);
var
  AudioConversion:TAudioConversion;
  OldButton4State:Boolean;
begin
  EncodeButton.Enabled := False;
  SpeedButton3.Enabled := False;
  SpeedButton2.Enabled := False;
  OldButton4State := Button4.Enabled;
  Button4.Enabled := False;
  if not SourceAudio.OpenReadStream then
    raise exception.Create('Cannot open Readstream');

  if not DestinationAudio.OpenWriteStream then
    raise exception.Create('Cannot open Writestream');

  AudioConversion:=TAudioConversion.create;
  try
    AudioConversion.InputAudio := SourceAudio;
    AudioConversion.OutputAudio := DestinationAudio;
    Label3.Repaint;
    UpdateTime := Now;
    AudioConversion.Normalize := Normalize.Checked;
    AudioConversion.OnProgress := AudioConversionProgress;
    AudioConversion.Convert;
  finally
    AudioConversion.Free;
  end;

  EncodeButton.Enabled := True;
  SpeedButton3.Enabled := True;
  SpeedButton2.Enabled := True;
  Button4.Enabled := OldButton4State;  
end;

procedure TDunesAudioDemoForm.cbCDDrivesChange(Sender: TObject);
var
  i:integer;
begin
  {$IFDEF WIN32}
  AudioCDRip.SelectDriveByIndex(cbCDDrives.ItemIndex);
  clTracks.Items.Clear;
  for i:=0 to AudioCDRip.TrackCount-1 do
    clTracks.Items.Add(AudioCDRip.Tracks[i].AudioTag.Title);
  {$ENDIF}
end;

procedure TDunesAudioDemoForm.DestinationTypeComboBoxChange(Sender: TObject);
var
  AudioClass:TAudioClass;
  i:integer;
begin
  cbSubFormat.Items.BeginUpdate;
  try
    cbSubFormat.Clear;

    AudioClass := Audio.GetAudioByDescription(DestinationTypeComboBox.Text);
    if assigned(AudioClass) then
    begin
      for i := 0 to 100 do
      begin
        if AudioClass.DefaultExtension(i) <> EmptyWideStr then
          cbSubFormat.Items.Add(AudioClass.DefaultExtension(i));
      end;

      QualityComboboxChange(Self);

    end;
  finally
    cbSubFormat.Items.EndUpdate;
    if cbSubFormat.Items.Count > 0 then
      cbSubFormat.ItemIndex := 0;
  end;
end;

end.
